import pytest

import spacy
from spacy import displacy

from src.generators import Generator
from src.strategies import leaf_strategy

nlp = spacy.load("en_core_web_trf")

@pytest.mark.parametrize('text, expected', [
    ('Regex for redacted phone numbers with extra info for PlayStation', ['PhoneNumberRegex', 'RedactedPhoneNumberRegex'])
])
def test_leaf_strategy(text, expected):
    generator = Generator(text=text, strategy=leaf_strategy)

    results = generator.suggest()

    doc = generator.doc
    for token in doc:
        print(token)

    print(results)
    # assert result == expected